<?PHP
/* Copyright 2012, Bergware International.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 */
?>
<?
$sleep = $sf_ini['sleep'];
$sName = "s3_sleep";
$script = "/usr/local/sbin/$sName";
$sFind = exec("find /boot -maxdepth 3 -name $sName");
if (strlen($sFind)) {
  $sCurrent = exec("$script -V | cut -f3 -d' '");
  $sVersion = exec("$sFind -V | cut -f3 -d' '");
  if ($sVersion > $sCurrent) $script = $sFind;
}
unset($sPorts);
exec("ifconfig -s | grep eth | cut -d' ' -f1", &$sPorts);
$sTimeout = 30;
$sInterval = 5;
$bwm_ng = is_file("/usr/bin/bwm-ng") ? '0' : '1';
$dayname = array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
?>
<form name="sleep" method="POST" action="/update.php" target="progressFrame" onsubmit="prepare(this)">
<input type="hidden" name="section" value="sleep">
<input type="hidden" name="script" value="<?=$script?>">
<table class="settings">
<tr>
<td>S3 Sleep Function:</td>
<td><select name="s3" size="1" onChange="activateS3sleep(this.form);">
<?=mk_option($sleep['s3'], "0", "Disabled")?>
<?=mk_option($sleep['s3'], "1", "Enabled")?>
</select>(<?=exec("$script -V")?>)</td>
</tr>
<tr>
<td>Wait for Array Inactivity:</td>
<td><select name="checkHDD" size="1" onChange="activateTimeout(this.form);">
<?=mk_option($sleep['checkHDD'], "", "No")?>
<?=mk_option($sleep['checkHDD'], "-a", "Yes")?>
</select></td>
</tr>
<tr>
<td>Extra Delay after Array Inactivity (minutes):</td>
<td><input type="text" name="timeout" maxlength="2" value="<?=$sleep['timeout']?>"><?=$sleep['timeout']==$sTimeout?'default':'user-set'?></td>
</tr>
<tr>
<td>Interval of Network / Device Inactivity (minutes):</td>
<td><input type="text" name="interval" maxlength="2" value="<?=$sleep['interval']?>"><?=$sleep['interval']==$sInterval?'default':'user-set'?></td>
</tr>
<tr>
<td>Ethernet Interface:</td>
<td><select name="eth" size="1">
<?foreach ($sPorts as $eth):?>
<?=mk_option_check($sleep['eth'], $eth, $eth)?>
<?endforeach;?>
</select></td>
</tr>
<tr>
<td>Wait for Network Inactivity:</td>
<td><select name="checkTCP" size="1">
<?=mk_option($sleep['checkTCP'], "", "No")?>
<?=mk_option($sleep['checkTCP'], "-n", "Yes")?>
</select><? if ($bwm_ng=='1') echo "BWM-NG is not installed"; ?></td>
</tr>
<tr>
<td>Wait for Device Inactivity (address):</td>
<td><input type="text" name="pingIP" maxlength="200" value="<?=$sleep['pingIP']?>">(e.g. 192.168.1.2)</td>
</tr>
<td>Excluded Hours:</td>
<td><select id="s2" name="stopHour" size="1" multiple="multiple" style="display:none">
<option value='' selected></option>
<?for ($h = 0; $h < 24; $h++):?>
<?=mk_option_check($sleep['stopHour'], sprintf("%02d", $h), sprintf("%02d:00 - %02d:00", $h,$h+1))?>
<?endfor;?>
</select></td>
</tr>
<tr>
<td>Excluded Days:</td>
<td><select id="s1" name="stopDay" size="1" multiple="multiple" style="display:none">
<option value='' selected></option>
<?for ($d = 0; $d < 7; $d++):?>
<?=mk_option_check($sleep['stopDay'], sprintf("%d", $d), $dayname[$d])?>
<?endfor;?>
</select></td>
</tr>
<tr>
<td>DHCP Renewal after wake-up:</td>
<td><select name="dhcpRenew" size="1">
<?=mk_option($sleep['dhcpRenew'], "", "No")?>
<?=mk_option($sleep['dhcpRenew'], "-R", "Yes")?>
</select></td>
</tr>
<tr>
<td>Force Gigabit Speed after wake-up:</td>
<td><select name="forceGb" size="1">
<?=mk_option($sleep['forceGb'], "", "No")?>
<?=mk_option($sleep['forceGb'], "-F", "Yes")?>
</select></td>
</tr>
<tr>
<td>Set WOL options before sleep:</td>
<td><input type="text" name="setWol" maxlength="8" value="<?=$sleep['setWol']?>">(e.g. ug, or any combination of options [pumbagsd] if they are support by NIC)</td>
</tr>
<tr>
<td></td>
<td><input type="submit" name="s3sleep" value="Apply"><button type="button" onClick="done();">Done</button></td>
</tr>
</table>
</form>

<script type="text/javascript">
$(document).ready(function() {
  $("#s1").dropdownchecklist({emptyText:'None', width:300, explicitClose:'...close'});
  $("#s2").dropdownchecklist({emptyText:'None', width:300, explicitClose:'...close'});
});

function prepare(form) {
  var days = '';
  for (var i=0,item; item=form.stopDay.options[i]; i++) {
    if (item.selected) {
      if (days.length) days += ' ';
      days += item.value;
      item.selected = false;
    }
  }
  item = form.stopDay.options[0];
  item.value = days;
  item.selected = true;
  var hours = '';
  for (var i=0,item; item=form.stopHour.options[i]; i++) {
    if (item.selected) {
      if (hours.length) hours += ' ';
      hours += item.value;
      item.selected = false;
    }
  }
  item = form.stopHour.options[0];
  item.value = hours;
  item.selected = true;
  form.pingIP.value = form.pingIP.value.replace(/,/g,' ').replace(/\s+/g,' ');
  form.setWol.value = form.setWol.value.replace(/\s+/g,'');
  if (!form.timeout.value || isNaN(form.timeout.value)) form.timeout.value = <?=$sTimeout?>;
  if (!form.interval.value || isNaN(form.interval.value)) form.interval.value = <?=$sInterval?>;
  if (!form.eth.value) form.eth.value = 'eth0';
}

function activateS3sleep(form) {
  var disabled = form.s3.value==0;
  form.checkHDD.disabled = disabled;
  form.checkTCP.disabled = disabled || <?=$bwm_ng?>;
  form.timeout.disabled = disabled || !form.checkHDD.value;
  form.eth.disabled = disabled;
  form.interval.disabled = disabled;
  form.pingIP.disabled = disabled;
  form.stopHour.disabled = disabled;
  form.dhcpRenew.disabled = disabled;
  form.forceGb.disabled = disabled;
  form.setWol.disabled = disabled;
  if (!form.timeout.value) form.timeout.value = <?=$sTimeout?>;
  if (!form.interval.value) form.interval.value = <?=$sInterval?>;
}
function activateTimeout(form) {
  form.timeout.disabled = form.checkHDD.value=="";
}

activateS3sleep(document.sleep);
</script>